library si32help;
uses WinTypes, WinProcs,Sysutils,Shellapi,Messages;
{$R whver32.res}
var Helppath: array [0..255] of Char;
	Helphandle: THandle;
	Helpini: array [byte] of Char;
{Exit variables}
var	SaveExit : pointer;
{Messagebox variables}
{Cripplers}
	Fetched: String;
	Gotastring: Bool;


procedure YieldAppToDLL;
var MSG: TMsg;
	Handle: THandle;
begin
	Handle := 0;
	while PeekMessage(Msg,Handle, 0, 0, PM_REMOVE) = True
		do if(Msg.message = 18)	then begin
			PostQuitMessage(0);
		end	else begin
			TranslateMessage(Msg);
			DispatchMessage(Msg);
	end;
end;


procedure SISInit(HPath: PChar;HHandle:Longint);Export;Stdcall;
begin
	StrCopy(Helppath,HPath);
	Helphandle := HHandle;
	StrPCopy(Helpini,ChangeFileExt(StrPas(HPath),'.INI'));
	YieldAppToDll;
end;
exports SISInit index 37;



function WHGetColorDepth(AskedParam: Integer): Bool; Export; StdCall;
var DCon: hDc;
begin
	DCon := GetDeviceCaps(GetDC(GetActiveWindow), BITSPIXEL);
	WHGetColorDepth := False;
	If AskedParam <= DCon Then WHGetColorDepth := True;
	ReleaseDC(GetActiveWindow,GetDC(GetActiveWindow));
end;
exports WHGetColorDepth index 11;

function WHGCD(AskedParam: Integer): Bool; Export; StdCall;
begin WHGCD := WHGetColorDepth(Askedparam); end;
exports WHGCD index 12;



Function WHMessageBox (wnd : Longint; messagecaption : PChar; messagetext: PChar; messageflags: Integer) : Boolean; Export; StdCall;
var	messagestring: string;
	Tildeval: integer;
begin
	Messagestring := StrPas(Messagetext);
	While Pos('~~',Messagestring) <> 0 do begin
		Tildeval := Pos('~~',messagestring);
		Delete(Messagestring,Tildeval,2);
		Insert(Chr(10),messagestring,TildeVal);
		end;
	StrPCopy(messagetext,messagestring);
	case MessageBox (GetActiveWindow, messagecaption, messagetext, messageflags) of
		idOK, idYes, idRetry : WHMessageBox:= True else WHMessageBox := True;
	end;
end;
exports WHMessageBox index 21;

Function WHMB (wnd : Longint; messagecaption : PChar; messagetext: PChar; messageflags: Integer) : Boolean; Export; StdCall;
begin
	WHMB := WHMessageBox (wnd, messagecaption, messagetext, messageflags)
end;
exports WHMB index 22;



procedure WHWritePrivateProfileString(ApplicationName, KeyName, Str,
  FileName: PChar); Export; StdCall;
Begin
	 WritePrivateProfileString(ApplicationName, KeyName, Str, FileName);
end;
exports WHWritePrivateProfileString index 23;

procedure WHWPPS(ApplicationName, KeyName, Str, FileName: PChar); Export; StdCall;
Begin
	 WritePrivateProfileString(ApplicationName, KeyName, Str, FileName)
end;
exports WHWPPS index 24;



function WHIfPrivateProfileString(Section, KeyName, Str,FileName: PChar): Bool; Export; StdCall;
var ReturnedString: array[0..255] of Char;
begin
GetPrivateProfileString(section,
	keyname, '', ReturnedString, SizeOf(ReturnedString), FileName);
  If StrPas(Str) = StrPas(ReturnedString) Then WHIfPrivateProfileString := True
  Else WHIfPrivateProfileString := False;
end;
exports WHIfPrivateProfileString index 25;

function WHIPPS(Section, KeyName, Str, FileName: PChar): Bool; Export; StdCall;
begin
	WHIPPS := WHIfPrivateProfileString(Section, KeyName, Str, FileName);
end;
exports WHIPPS index 26;



function WHIfSecondary:Bool;Export; StdCall;
var p1: array [0..99] of Char;
begin
	Getclassname(GetActiveWindow,P1,SizeOf(P1));
	If StrPas(P1) = 'MS_WINTOPIC_SECONDARY' Then WHIfSecondary := True Else WHIfSecondary := False;
end;
exports WHIfSecondary index 43;
function WHIS:Bool;Export; StdCall;
begin WHIS := WHIfSecondary; end;
exports WHIS index 44;


procedure WHSetClipboardData(Cliptext: PChar); Export; StdCall;
var	hLoc: THandle;
var c2: array [0..255] of Char;
var	Messagestring: string;
	Tildeval: integer;
begin
	Messagestring := StrPas(ClipText);
	While Pos('~~',Messagestring) <> 0 do begin
		Tildeval := Pos('~~',messagestring);
		Delete(Messagestring,Tildeval,2);
		Insert(Chr(10),messagestring,TildeVal);
	end;
	While Pos('^^',Messagestring) <> 0 do begin
		Tildeval := Pos('^^',messagestring);
		Delete(Messagestring,Tildeval,2);
		Insert(Chr(13) + Chr(10),messagestring,TildeVal);
	end;
	StrPCopy(C2,MessageString);
	If EmptyClipboard = False then CloseClipboard;
	If OpenClipboard(GetActiveWindow) = True Then Begin
		hLoc := GlobalAlloc( GHND, SizeOf(C2) + 1);
		strcopy(GlobalLock(hLoc), C2);
		GlobalUnlock( hLoc );
		SetClipboardData( CF_TEXT, hLoc );
		CloseClipboard;
	YieldAppToDll;
	end;
end;
exports WHSetClipboardData index 45;
procedure WHSCD(Cliptext: PChar); Export; StdCall;
begin
	WHSetClipboardData(Cliptext);
end;
exports WHSCD index 46;


function WHMessageBoxEnhanced(St1,St2,St3,St4,St5,St6,Cap:PChar;
	Flags:Integer):Bool;Export;{$IFDEF WIN32} StdCall; {$ENDIF}
var Pc1: array [0..1500] of Char;
	temP1,P1,P2,P3,P4,P5,P6: array [byte] of Char;
const MsgKey: array [0..10] of Char = 'Messages';

	function FatValidate(MessageString:String):String;
	var Tildeval: Byte;
	begin
		While Pos('~~',Messagestring) <> 0 do begin
			Tildeval := Pos('~~',messagestring);
			Delete(Messagestring,Tildeval,2);
			Insert(Chr(10),messagestring,TildeVal);
		end;
		While Pos('>>',Messagestring) <> 0 do begin
			Tildeval := Pos('>>',messagestring);
			Delete(Messagestring,Tildeval,2);
			Insert(' ',messagestring,TildeVal);
		end;
		Result := Messagestring;
	end;

begin
	Result := False;
	If StrPas(St1) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St1,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P1,FatValidate(StrPas(temP1)));
		lstrcpy(@Pc1,P1);
	end else lstrcpy(@Pc1,'');
	If StrPas(St2) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St2,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P2,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P2);
	end;
	If StrPas(St3) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St3,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P3,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P3);
	end;
	If StrPas(St4) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St4,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P4,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P4);
	end;
	If StrPas(St5) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St5,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P5,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P5);
	end;
	If StrPas(St6) <> StrPas('') then begin
		GetPrivateProfileString(MsgKey,St6,'',temP1,SizeOf(temP1),HelpIni);
		StrPCopy(P6,FatValidate(StrPas(temP1)));
		lstrcat(@Pc1,P6);
	end;
{Null string?}
	StrPCopy(P1,Pc1[0] + Pc1[1] + Pc1[2]);
	If Length(StrPas(P1)) < 2 then begin
		StrPCopy(P1,'No message entries found...this software may require '
			+'reinstallation to repair a damaged .INI file.');
		lstrcpy(@Pc1,P1);
	end;
{Generate a messagebox}
	case MessageBox (GetActiveWindow,Pc1,Cap,Flags) of
		idOK, idYes, idRetry : Result := True;
		idCancel, idAbort, idNo, idIgnore : Result:= False;
	end;
	YieldAppTodll;
end;
exports WHMessageBoxEnhanced index 55;
function WHMBE(St1,St2,St3,St4,St5,St6,Cap:PChar;
	Flags:Integer):Bool;Export;{$IFDEF WIN32} StdCall; {$ENDIF}
begin
	Result := WHMessageBoxEnhanced(St1,St2,St3,St4,St5,St6,Cap,Flags);
end;
exports WHMBE index 56;



function WHGetPrivateProfileString(Section,Keyname,INIFile:PChar):Pointer;Export;Stdcall;
var 	Ret1: array [0..255] of Char;
begin
	If Gotastring = False then begin
		GetPrivateProfileString(Section,Keyname,#160,Ret1,SizeOf(Ret1),INIFile);
		Fetched := StrPas(Ret1);
	end;
	WHGetPrivateProfileString := Pchar(Fetched);
	YieldApptoDll;
end;
exports WHGetPrivateProfileString index 41;
function WHGPPS(Section,Keyname,INIFile:PChar):Pointer;Export;Stdcall;
begin
	WHGPPS := WHGetPrivateProfileString(Section,Keyname,INIFile);
end;
exports WHGPPS index 42;



procedure DLLExitProc; far;
begin
	ExitProc := SaveExit;
end;


begin
  SaveExit := ExitProc;
  ExitProc := @DLLExitProc;
end.
